      PROGRAM TZHEEV4
*
*       ணࠬ   PZHEEV4
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            LWORK, MAXN, LDA, MAXPROCS, NOUT, LRWORK,
     $                   LIWORK
      DOUBLE PRECISION   ZERO, MONE
      PARAMETER          ( LDA = 100, LWORK = 5512, LIWORK = 30,
     $                   LRWORK = 40,
*      PARAMETER          ( LDA = 100, LWORK = -1, LIWORK = -1,
*     $                   LRWORK = -1,
     $                   MAXN = 100, MAXPROCS = 512, NOUT =6,
     $                   ZERO = 0.0D+0, MONE = -1.0D+0 )
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'U' )
*
*  ६ ..
      INTEGER            CTXT, I, IAM, INFO, MYCOL, MYROW, N, NB,
     $                   NPCOL, NPROCS, NPROW, IA, JA, IZ, JZ
      DOUBLE PRECISION   VL, VU, ABSTOL, ORFAC
*
*  ᨢ ..
*      INTEGER            DESCA( 9 ), DESCZ( 9 ), IWORK(30),
      INTEGER            DESCA( 9 ), DESCZ( 9 ), IWORK(LIWORK),
     $                   IFAIL(4), ICLUSTR(8)
*
      DOUBLE PRECISION   W( MAXN ), GAP(4),
     $                   RWORK( LRWORK )
*     $                   RWORK( 40 )
*
      DOUBLE COMPLEX     A( LDA, LDA ), Z( LDA, LDA ), WORK1( 4 ),
     $                   WORK( LWORK )
*     $                   WORK( 5512 )
*
* 譨 ணࠬ ..
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDMATINIT, PZLAPRNT,
     $                   PZHEEV4, PDLAMCH
*
* 믮塞  ..
*
* ⠭ 
*
      N = 4
      NB = 1
      NPROW = 2
      NPCOL = 2
      IA = 1
      JA = 1
      IZ = 1
      JZ = 1
      VL = -1.0D0
      VU = 1.0D0
      ORFAC = 0.0D0
*
* 樠  BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
      IF( ( NPROCS.LT.1 ) ) THEN
         CALL BLACS_SETUP( IAM, NPROW*NPCOL )
      END IF
*
* 樠 ⥪ BLACS'  ⪨ ᮢ
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨      ⥪,
* 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 20
*
      ABSTOL = 2.0D0* PDLAMCH(CTXT,'U')
*
* 樠 ਯ஢   A  Z
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
      CALL DESCINIT( DESCZ, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
*
* ஥  A
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9992 )
         WRITE( NOUT, FMT = 9998 )N, N, NB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9988 ) UPLO
         WRITE( NOUT, FMT = 9995 ) VL, VU
         WRITE( NOUT, FMT = 9993 ) ABSTOL, ORFAC
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCZ'
         WRITE( NOUT, FMT = 9985 )DESCZ
         WRITE( NOUT, FMT = * ) '  A'
      END IF
 9985 FORMAT( / 9I5 /)
 9988 FORMAT( / ' UPLO = ', A /)
 9995 FORMAT( / ' VL =', D15.6, '   VU =', D15.6 / )
 9993 FORMAT( / ' ABSTOL =', D15.6, '   ORFAC =', D15.6 /)
*
      CALL PZLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
* ᫥ ᮡ⢥ 祭  ᮡ⢥ ஢
*
      CALL PZHEEV4( UPLO, N, A, IA, JA, DESCA, VL, VU, ABSTOL, M, NZ,
     $              W, ORFAC, Z, IZ, JZ, DESCZ, WORK, LWORK, RWORK,
     $              LRWORK, IWORK, LIWORK, IFAIL, ICLUSTR, GAP, INFO )
*
*  १⮢
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = 9986 )M, NZ
         WRITE( NOUT, FMT = 9981 )IFAIL, ICLUSTR
*         WRITE( NOUT, FMT = 9986 )WORK(1), IWORK(1), RWORK(1)
         WRITE( NOUT, FMT = * ) ' ᮡ⢥ ᫠'
         DO 10 I = 1, M
            PRINT *, ' W(', I, ')=', W( I ), ';'
   10    CONTINUE
         WRITE( NOUT, FMT = * ) ' ᮡ⢥ '
      END IF
*
*  ᮡ⢥ ஢
*
      CALL PZLAPRNT( N, M, Z, IZ, JZ, DESCZ, 0, 0, 'Z', NOUT, WORK1 )
*
      CALL BLACS_GRIDEXIT( CTXT )
*
   20 CONTINUE
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( 'W=diag([', 4D16.12, //']);' )
*
 9992 FORMAT( / '  ணࠬ PZHEEV4' )
 9998 FORMAT( / ' ᫥ ᮡ⢥ 祭  ᮡ⢥',
     $  ' ஢   A' /
     $       '  ࢠ ( VL, VU ),' //
     $      '  A - ନ⮢  ',
     $      I2, '  ', I2,',',
     $       ' ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I3)
* 9986 FORMAT( / ' WORK(1) =', (D15.5, D15.5), ' IWORK(1) =', I3,
*     $       '  RWORK(1) =', D15.5 /)
 9986 FORMAT( / ' M =',I3, '     NZ =',I3 /)
 9981 FORMAT( / ' IFAIL =',4I5/ '  ICLUSTR =',8I3 //)
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
* PDMATINIT   ।  A  ⪥ ᮢ
*
      INTEGER            DLEN_, CTXT_
      PARAMETER          ( DLEN_ = 9, CTXT_ = 2 )
      DOUBLE COMPLEX  ONE
      PARAMETER          ( ONE = (1.0D+0, 0.0D0) )
      INTEGER            IA, INFO, JA, N
      INTEGER            DESCA( * )
      DOUBLE COMPLEX     A( * )
      INTEGER            I, J, MYCOL, MYROW, NPCOL, NPROW
      EXTERNAL           BLACS_GRIDINFO, PZELSET
      INTRINSIC          DBLE
*
      INFO = 0
*
      CALL BLACS_GRIDINFO( DESCA( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF( JA.NE.1 ) THEN
         INFO = -4
      END IF
*
      DO 20 J = 1, N
         DO 10 I = 1, N
            IF( I.EQ.J ) THEN
               CALL PZELSET( A, I, J, DESCA,
     $                       ( DBLE( N-I+1 ) ) / DBLE( N )+ONE /
     $                       ( DBLE( I+J )-ONE ) )
            ELSE
               CALL PZELSET( A, I, J, DESCA, ONE / ( DBLE( I+J )-ONE ) )
            END IF
   10    CONTINUE
   20 CONTINUE
*
      RETURN
*
*     End of PDMATINIT
*
      END
